#!/usr/bin/perl

#

# Toggle debugging.
my $debug = 0;
use strict;

# getopts
use AnalyseLV2;
use Getopt::Std;
our( $opt_h, $opt_s );
my @matches;

# main Stuff goes here:
# First make sure we have the utilities.
AnalyseLV2::find_utils() || die "Couldn't find lv2 utilities! are they in your \$PATH?";
getopts('sh');
my @args = @ARGV;

if (@args > 0 && $args[0] =~ /\:|\// ) {
	(my $pinfo, my $scinfo) = AnalyseLV2::_analyse_lv2($args[0]);
	die "Error: $pinfo->{'ERROR'}\n" if exists($pinfo->{'ERROR'});
	if ($opt_s) { print AnalyseLV2::print_lv2_scalepoints(); }
	else { print AnalyseLV2::print_lv2(); }
} elsif (@args == 0 || $opt_h ) { print_help(); }
elsif ($args[0] =~ /.+/) {
	print "Performing fuzzy search on $args[0]:\n";;
	@matches = AnalyseLV2::trymatch($args[0]);
	if ( @matches == 1 ) {
		AnalyseLV2::_analyse_lv2($matches[0]);
		if ($opt_s) { print AnalyseLV2::print_lv2_scalepoints(); }
		else { print AnalyseLV2::print_lv2(); }
	} elsif (@matches > 1) {
		my $matches = @matches;
		print "($matches matches found.)\n";
		for (my $I=0; $I < @matches; $I++) {
			print "$matches[$I]\n";
		}
	} else{
		print "No match found.\n";
	}
} else {

	print "Something didn't quite work...\n";
	print_help();
}

sub print_help {
	print "USAGE: 
	analyselv2 [OPTIONS] <URI|STRING>
	Supported options:
	-s - Print options for ports marked as 'Selector'.
	(The programme takes exactly ONE argument.)\n";
}


# TODO:
# - Nothing for now.
